-- Swinger v1
-- by Tehl of Defias Brotherhood

lastSwing = 0
parried = false

function Swinger_Event()
	if (event == "VARIABLES_LOADED") then
		Swinger_Init()
	else
		if (string.find(arg1, "You parry.")) then
			parried = true
		elseif (string.find(arg1, "You hit ") or string.find(arg1, "You crit ") or string.find(arg1, "You miss ") or string.find(arg1, "You attack. ") or string.find(arg1, "Your Heroic Strike ") or string.find(arg1, "Your Cleave ") or string.find(arg1, "Your Raptor Strike ") or string.find(arg1, "Your Maul ")) then
			parried = false
			lastSwing = GetTime()
		end
	end
end

function Swinger_Update()
	if (Swinger_Config["locked"] == false) then
		Swinger:Show()
		SwingerBar:SetMinMaxValues(1, 100)
		SwingerBar:SetValue(100)
	else
		local speed = UnitAttackSpeed("player")
		if (parried) then
			-- parrying reduces the time to next swing by 40% of base swing speed
			speed = speed * 0.6
		end
		if (GetTime() > lastSwing + speed) then
			Swinger:Hide()
		else
			Swinger:Show()
			SwingerBar:SetMinMaxValues(lastSwing, lastSwing + speed)
			SwingerBar:SetValue(GetTime())
			local remaining = floor((lastSwing + speed - GetTime()) * 10) / 10
			if (math.fmod(remaining, 1) == 0) then
				remaining = remaining..".0"
			end
			SwingerBarText:SetText(remaining.."s")
		end
	end
end

function Swinger_Init()
	if not (Swinger_Config) then
		Swinger_Config = {
			["width"] = 200,
			["height"] = 20,
			["locked"] = false,
			["x"] = 640,
			["y"] = 480,
			["r"] = 0.7,
			["g"] = 0.7,
			["b"] = 1.0,
		}
		Swinger_ConfigPane:Show()
	end
	
	SwingerBar:SetStatusBarColor(Swinger_Config["r"], Swinger_Config["g"], Swinger_Config["b"])
	Swinger_UpdatePosition()
	
	if (Swinger_Config["locked"] == true) then
		Swinger_ConfigPane_Locked:SetChecked(true)
	else
		Swinger_ConfigPane_Locked:SetChecked(false)
	end
	Swinger_ConfigPane_Height:SetMinMaxValues(15, 35)
	Swinger_ConfigPane_HeightLow:SetText(15)
	Swinger_ConfigPane_HeightHigh:SetText(35)
	Swinger_ConfigPane_Height:SetValueStep(1)
	Swinger_ConfigPane_Height:SetValue(Swinger_Config["height"])
	Swinger_ConfigPane_Width:SetMinMaxValues(50, 300)
	Swinger_ConfigPane_WidthLow:SetText(50)
	Swinger_ConfigPane_WidthHigh:SetText(300)
	Swinger_ConfigPane_Width:SetValueStep(1)
	Swinger_ConfigPane_Width:SetValue(Swinger_Config["width"])
	Swinger_ConfigPane_Colour_ColorSwatch:SetTexture(Swinger_Config["r"], Swinger_Config["g"], Swinger_Config["b"])
	
	SLASH_SWINGER1 = "/swinger"
	SlashCmdList["SWINGER"] = Swinger_Slash
end

function Swinger_Slash()
	Swinger_ConfigPane:Show()
end

function Swinger_UpdatePosition()
	Swinger:SetWidth(Swinger_Config["width"])
	Swinger:SetHeight(Swinger_Config["height"])
	
	SwingerBackdrop:SetWidth(Swinger_Config["width"])
	SwingerBackdrop:SetHeight(Swinger_Config["height"])
	
	SwingerBar:SetWidth(Swinger_Config["width"])
	SwingerBar:SetHeight(Swinger_Config["height"])
	
	Swinger:ClearAllPoints()
	Swinger:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", Swinger_Config["x"], Swinger_Config["y"])
end

function Swinger_ColorPicker()
	local r, g, b = ColorPickerFrame:GetColorRGB()
	Swinger_Config["r"] = r
	Swinger_Config["g"] = g
	Swinger_Config["b"] = b
	SwingerBar:SetStatusBarColor(r, g, b)
	Swinger_ConfigPane_Colour_ColorSwatch:SetTexture(r, g, b)
end

function Swinger_ColorPickerCancel(prevvals)
	local r,g,b = unpack(prevvals)
	Swinger_Config["r"] = r
	Swinger_Config["g"] = g
	Swinger_Config["b"] = b
	SwingerBar:SetStatusBarColor(r, g, b)
	Swinger_ConfigPane_Colour_ColorSwatch:SetTexture(r, g, b)
end
